//COBCLG   JOB (001),'COBOL COMPILE',CLASS=A,MSGCLASS=X                 00010000
//RWEX01   EXEC COBUCLG                                                 00020011
//COB.SYSIN DD *                                                        00030011
000100 IDENTIFICATION DIVISION.
000200 PROGRAM-ID. RWEX01.
000300 AUTHOR. JAY MOSELEY.
000400 DATE-WRITTEN. MARCH, 2008.
000500 DATE-COMPILED.
000600
000700* ************************************************************* *
000800* REPORT WRITER EXAMPLE #1.                                     *
000900* ************************************************************* *
001000
001100 ENVIRONMENT DIVISION.
001200 CONFIGURATION SECTION.
001300 SOURCE-COMPUTER. IBM-370.
001400 OBJECT-COMPUTER. IBM-370.
001500
001600 INPUT-OUTPUT SECTION.
001700 FILE-CONTROL.
001800
001900     SELECT TRANSACTION-DATA
002000         ASSIGN TO UT-S-DATAIN.
002100
002200     SELECT REPORT-FILE
002300         ASSIGN TO UR-S-SYSPRINT.
002400
002500 DATA DIVISION.
002600 FILE SECTION.
002700
002800 FD  TRANSACTION-DATA
002900     LABEL RECORDS ARE OMITTED
003000     BLOCK CONTAINS 0 RECORDS
003100     RECORD CONTAINS 80 CHARACTERS
003200     DATA RECORD IS TRANSACTION-RECORD.
003300
003400 01  TRANSACTION-RECORD.
003500     03  TR-CUSTOMER-NUMBER      PIC 9(04).
003600     03  FILLER                  PIC X(01).
003700     03  TR-CUSTOMER-NAME        PIC X(16).
003800     03  FILLER                  PIC X(01).
003900     03  TR-ITEM-NUMBER          PIC 9(05).
004000     03  FILLER                  REDEFINES TR-ITEM-NUMBER.
004100         05  TR-ITEM-DEPARTMENT  PIC 9(01).
004200         05  FILLER              PIC 9(04).
004300     03  FILLER                  PIC X(01).
004400     03  TR-ITEM-COST            PIC 9(03)V99.
004500     03  FILLER                  PIC X(47).
004600
004700 FD  REPORT-FILE
004800     LABEL RECORDS ARE OMITTED
004900     REPORT IS CUSTOMER-REPORT.
005000
005100 WORKING-STORAGE SECTION.
005200 77  END-OF-FILE-SWITCH          PIC X(1)    VALUE 'N'.
005300     88  END-OF-FILE                         VALUE 'Y'.
005400
005500 REPORT SECTION.
005600 RD  CUSTOMER-REPORT
005700     PAGE LIMIT IS 66 LINES
005800     HEADING 1
005900     FIRST DETAIL 5
006000     LAST DETAIL 58.
006100
006200 01  PAGE-HEAD-GROUP TYPE PAGE HEADING.
006300     02  LINE 1.
006400         03  COLUMN 27   PIC X(41) VALUE
006500             'C U S T O M E R  C H A R G E  R E P O R T'.
006600     02  LINE PLUS 2.
006700         03  COLUMN 01   PIC X(09) VALUE 'CUST. NO.'.
006800         03  COLUMN 15   PIC X(10) VALUE 'CUST. NAME'.
006900         03  COLUMN 30   PIC X(05) VALUE 'DEPT.'.
007000         03  COLUMN 39   PIC X(08) VALUE 'ITEM NO.'.
007100         03  COLUMN 51   PIC X(09) VALUE 'ITEM COST'.
007200
007300 01  CHARGE-DETAIL TYPE DETAIL.
007400     02  LINE PLUS 1.
007500         03  COLUMN 03   PIC Z(04) SOURCE TR-CUSTOMER-NUMBER.
007600         03  COLUMN 10   PIC X(16) SOURCE TR-CUSTOMER-NAME.
007700         03  COLUMN 32   PIC 9(01) SOURCE TR-ITEM-DEPARTMENT.
007800         03  COLUMN 40   PIC 9(05) SOURCE TR-ITEM-NUMBER.
007900         03  COLUMN 51   PIC $$$$.99 SOURCE TR-ITEM-COST.
008000
008100 PROCEDURE DIVISION.
008200
008300 000-INITIATE.
008400
008500     OPEN INPUT TRANSACTION-DATA,
008600          OUTPUT REPORT-FILE.
008700
008800     INITIATE CUSTOMER-REPORT.
008900
009000     READ TRANSACTION-DATA
009100         AT END
009200             MOVE 'Y' TO END-OF-FILE-SWITCH.
009300*    END-READ.
009400
009500     PERFORM 100-PROCESS-TRANSACTION-DATA THRU 199-EXIT
009600         UNTIL END-OF-FILE.
009700
009800 000-TERMINATE.
009900     TERMINATE CUSTOMER-REPORT.
010000
010100     CLOSE TRANSACTION-DATA,
010200           REPORT-FILE.
010300
010400     STOP RUN.
010500
010600 100-PROCESS-TRANSACTION-DATA.
010700     GENERATE CHARGE-DETAIL.
010800     READ TRANSACTION-DATA
010900         AT END
011000             MOVE 'Y' TO END-OF-FILE-SWITCH.
011100*    END-READ.
011200
011300 199-EXIT.
011400     EXIT.
011500
011600
//GO.DATAIN DD *                                                        00040011
0152 J. LANGDON       87653 02475
0152 J. LANGDON       64025 00945
0152 J. LANGDON       41915 01370
0152 J. LANGDON       17410 00251
2468 L. MORRISEY      18520 00375
2468 L. MORRISEY      20012 00420
2468 L. MORRISEY      31572 01015
2468 L. MORRISEY      48792 03750
2468 L. MORRISEY      50407 01515
2468 L. MORRISEY      61575 02010
2468 L. MORRISEY      79204 05170
2468 L. MORRISEY      85075 03784
2468 L. MORRISEY      98476 08794
3451 M. JACKSON       37847 02790
3451 M. JACKSON       58492 06850
3451 M. JACKSON       60010 02040
3451 M. JACKSON       85260 07852
3451 M. JACKSON       90520 02752
4512 S. LEVITT        24680 03050
4512 S. LEVITT        56784 05253
4512 S. LEVITT        60410 01215
4512 S. LEVITT        78952 08925
4512 S. LEVITT        85278 04975
4512 S. LEVITT        87492 06425
4512 S. LEVITT        97204 08475
5417 K. CONKLIN       13579 03572
5417 K. CONKLIN       24615 01875
5417 K. CONKLIN       34928 03745
5417 K. CONKLIN       48527 08750
5417 K. CONKLIN       50150 01895
5417 K. CONKLIN       54652 03892
5417 K. CONKLIN       59765 09895
5417 K. CONKLIN       71572 01895
5417 K. CONKLIN       85175 08010
5417 K. CONKLIN       90275 00460
5417 K. CONKLIN       91572 01857
5417 K. CONKLIN       97576 08495
6213 Z. HAMPTON       15792 06425
6213 Z. HAMPTON       19975 09875
6213 Z. HAMPTON       34576 05115
6213 Z. HAMPTON       49512 08520
7545 M. LARSON        14676 03845
7545 M. LARSON        18592 08251
7545 M. LARSON        19994 09898
7545 M. LARSON        21214 01515
7545 M. LARSON        37515 08212
7545 M. LARSON        38592 09615
7545 M. LARSON        48485 08714
7545 M. LARSON        52762 03792
7545 M. LARSON        57684 08015
7545 M. LARSON        79015 09625
7545 M. LARSON        80123 00560
7545 M. LARSON        82462 02015
7545 M. LARSON        91520 01815
7545 M. LARSON        93715 04015
//GO.SYSPRINT DD SYSOUT=*                                               00050000
//                                                                      00060000
